#pragma rtGlobals=1		// Use modern global access method.
#pragma ModuleName=ImageCal

Function loadImageCalPanel()
    SetDataFolder root:images

    DoWindow/K ImageCalPanel
    NewPanel/K=1/W=(211,300,350,485) as "Image Calculation"
    DoWindow/C ImageCalPanel
    SetDrawLayer UserBack

    CheckBox RescaleCheck,pos={10,10},size={69,14},title="Rescale",value= 1
//    CheckBox KillCheck,pos={75,10},size={69,14},title="Kill Operand",value= 0
//    CheckBox AllCheck,pos={160,10},size={69,14},title="Apply to All",value= 1

    TitleBox img1 frame=0, pos={10,28}, title="Image #1"
    PopupMenu wave1Menu,pos={2,40},size={150,20}
    PopupMenu wave1Menu,mode=2,popvalue="_none_",value= "_none_;" + WaveList("*",";","") 
    Button invertImageButton,pos={10,65},size={55,20},proc=ImageCal#SingleImageCalButtonProc,title="Invert"  
    Button LnImageButton,pos={72,65},size={45,20},proc=ImageCal#SingleImageCalButtonProc,title="Ln"  
    Button rescaleImageButton,pos={10,88},size={55,20},proc=ImageCal#SingleImageCalButtonProc,title="rescale"  
    Button ODImageButton,pos={72,88},size={45,20},proc=ImageCal#SingleImageCalButtonProc,title="OD"  

    TitleBox img2 frame=0, pos={10,112}, title="Image #2"
    PopupMenu wave2Menu,pos={2,127},size={150,20}
    PopupMenu wave2Menu,mode=2,popvalue="_none_",value= "_none_;" + WaveList("*",";","")
    Button addImagesButton, pos={10,156},size={20,20},proc=ImageCal#twoImagesCalButtonProc,title="+"
    Button subtrImagesButton, pos={40,156},size={20,20},proc=ImageCal#twoImagesCalButtonProc,title="-"
    Button mulImagesButton, pos={70,156},size={20,20},proc=ImageCal#twoImagesCalButtonProc,title="x"
    Button divideImagesButton, pos={100,156},size={20,20},proc=ImageCal#twoImagesCalButtonProc,title="/"

    return 0
End

//==================================================================

Function SingleImageCalButtonProc(ctrlName): ButtonControl
    String ctrlName

    ControlInfo/W=ImageCalPanel wave1Menu 
    if (cmpstr(S_value, "_none_") == 0) // same string
        doAlert 0, "Choose an image in the top popup menu."
        return 0;
    endif

    print RemoveEnding(ctrlName,"Button")+ " " + S_value

    SetDataFolder root:images:
    WAVE operand = $S_value
    Variable imageBitInfo

    switch (CommonUsage#checkImageDatatype(S_value))
        case 72: // 8 bit unsigned int
            imageBitInfo = 255
        break
        case 80: // 16 bit unsigned int
            imageBitInfo = 65535
        break
        default:
            doAlert 0, "caution! the image to be calculated is neither 8 bit nor 16 bit!"
            WAVE M_tmp = $S_value
            ImageStats/M=1 M_tmp
            imageBitInfo = V_max
        break
    endswitch

    if (cmpstr(NameOfWave(operand), "M_Stack")==0)
        NVAR dimX = root:IP_consts:dimX
        NVAR dimY = root:IP_consts:dimY
        NVAR numImages = root:IP_consts:numImages
        if (cmpstr(ctrlName, "rescaleImageButton")==0)
            file_IO#convert_16_8bit("M_Stack")
            return 0
        endif
        
        Make/O/B/U/N=(dimX,dimY) tmp_slice
        switch (imageBitInfo)
        case 255:
        break
        case 65535:
            Redimension/U/W tmp_slice
        break
        default:
            doAlert 0, "the image to be calculated is neither 8 bit nor 16 bit! calculation stopped."
            return 1
        break
        endswitch

        doWindow/K stack_window
        SVAR oldImg = root:IP_consts:oldImg
        if (cmpstr(oldImg, "M_Stack")==0)
            oldImg = "none"
            KillWindow fileIO#preview
        endif

        WAVE M_Stack = root:images:M_Stack
        Variable k
        // operate on each slice
        for (k=0;k<numImages;k+=1)
            ImageTransform/P=(k) getPlane M_Stack
            WAVE M_ImagePlane = root:images:M_ImagePlane
            strswitch (ctrlName)
                case "invertImageButton":
                    ImageCal#IM_invert("M_ImagePlane", imageBitInfo)
                break
                case "LnImageButton":
                    MatrixOP/O M_=ln(M_ImagePlane)
                break
                case "ODImageButton":
                    ImageStats/M=1 M_ImagePlane
                    MatrixOP/O M_=(-1)*ln(M_ImagePlane/V_max)
                break
            endswitch
            tmp_slice = M_
            ImageTransform/P=(k)/D=tmp_slice setPlane M_Stack
        endfor
        KillWaves tmp_slice

        ControlInfo/W=ImageCalPanel RescaleCheck
        if (V_Value) // rescale is checked
            file_IO#convert_16_8bit("M_Stack")
        endif
        KillWaves M_

        return 0
    endif

    String flag ="";

    strswitch (ctrlName)
        case "invertImageButton":
            ImageCal#IM_invert(NameOfWave(operand), imageBitInfo)
            flag = "invert"
        break
        case "LnImageButton":
            MatrixOP/O M_=ln(operand)
            flag = "ln"
        break
        case "rescaleImageButton":
            file_IO#convert_16_8bit(NameOfWave(operand))
            flag = "rescale"
        break
        case "ODImageButton":
            ImageStats/M=1 operand
            MatrixOP/O M_=(-1)*ln(operand/V_max)
            flag = "OD"
        break
    endswitch

    if (cmpstr("rescale", flag)==0)
        return 0
    endif 

    ControlInfo/W=ImageCalPanel RescaleCheck
    if (V_Value) // rescale is checked
        file_IO#convert_16_8bit("M_")
    else
        switch (CommonUsage#checkImageDatatype(NameOfWave(operand)))
            case 72: // 8 bit unsigned int
                Redimension/B/U M_ 
            break
            case 80: // 16 bit unsigned int
                Redimension/W/U M_
            break
            default:
                doAlert 0, "caution! the calculated image is neither 8 bit nor 16 bit!"
            break
        endswitch
        Duplicate/O M_ $("M_"+flag)
    endif
    KillWaves M_

    file_IO#updateImageList()

    return 0
End

//==================================================================

Function twoImagesCalButtonProc(ctrlName): ButtonControl
    String ctrlName

    SetDataFolder root:images:

    ControlInfo/W=ImageCalPanel wave1Menu 
    if (cmpstr(S_value, "_none_") == 0) // same string
        doAlert 0, "Choose an image in the 1st popup menu."
        return 0;
    endif
    WAVE operand1 = $S_value

    if(cmpstr(S_value, "M_Stack")==0)
        doAlert 0, "dyatic operation on stack image is not supported."
        return 1
    endif

    ControlInfo/W=ImageCalPanel wave2Menu 
    if (cmpstr(S_value, "_none_") == 0) // same string
        doAlert 0, "Choose an image in the 2nd popup menu."
        return 0;
    endif
    WAVE operand2 = $S_value

    if (cmpstr(S_value,"M_Stack")==0)
        doAlert 0, "dyatic operation on stack image is not supported."
        return 1
    endif

    print RemoveEnding(ctrlName,"Button")+ " " + NameOfWave(operand1) + " " + NameOfWave(operand2)

    String flag ="";

    strswitch (ctrlName)
        case "addImagesButton":
            MatrixOP/O M_= operand1+operand2
            flag = "sum"
        break
        case "subtrImagesButton":
            MatrixOP/O M_=operand1-operand2 
            flag = "diff"
        break
        case "mulImagesButton":
            MatrixOP/O M_=operand1*operand2
            flag = "product"
        break
        case "divideImagesButton":
            FindValue/V=0 operand2
            if (V_value >-1)
                doAlert 0, "dividing 0!"
                return 2;
            endif
            MatrixOP/O M_=operand1/operand2
            flag = "quotient"
        break
    endswitch

    Duplicate/O M_ $("M_"+flag)
    KillWaves M_

    ControlInfo/W=ImageCalPanel RescaleCheck

    if (V_Value) // rescale is checked
        file_IO#convert_16_8bit("M_"+flag)
    endif

    file_IO#updateImageList()

    return 0
End

//==================================================================

Function IM_invert(imageName, bitInfo)
    String imageName
    Variable bitInfo

    WAVE tmp = $imageName
    MatrixOP/O M_= (-1)*tmp + bitInfo 
    
    return 0

End



