#pragma rtGlobals=2		// Use modern global access method.
#pragma ModuleName=imgThresh


Function doThresh(imageName)
    String imageName

    SetDataFolder root:images
    DoWindow/K threshhold_window
    NewImage/K=1/N=threshold_window $imageName

    Duplicate/O $imageName origin_img
    imgThresh#thresh_update()

    return 0;
End 

//==================================================================
Function thresh_update()

    NVAR threshold_high = root:IP_consts:threshold_high
    NVAR threshold_low = root:IP_consts:threshold_low

    SetDataFolder root:images
    WAVE origin_img = root:images:origin_img

    Variable imageBitInfo
    switch (CommonUsage#checkImageDatatype("origin_img"))
        case 72: // 8 bit unsigned int
            imageBitInfo = 255
        break
        case 80: // 16 bit unsigned int
            imageBitInfo = 65535
        break
        default:
            doAlert 0, "caution! the rescaled stack is neither 8 bit nor 16 bit!"
            ImageStats/M=1 origin_img
            imageBitInfo = V_max
        break
    endswitch

    Variable low = threshold_low * imageBitInfo
    Variable high = threshold_high * imageBitInfo


    RemoveImage/Z/W=threshold_window thresh_img
    MatrixOP/O thresh_img = greater(origin_img, high) + greater(origin_img, low) 

    AppendImage/W=threshold_window thresh_img
    ModifyImage/W=threshold_window thresh_img ctab= {0,2,Grays,0}

    return 0;
End

//==================================================================
Function thresholdProc(sa): SliderControl
    STRUCT WMSliderAction &sa
    
    NVAR thresh_on = root:IP_consts:thresh_on
    if (thresh_on == 0)
        return 0
    endif

    switch (sa.eventCode)
        case -1: // kill
            break
        default:
            if( sa.eventCode & 1 ) // value set
                imgThresh#thresh_update()
            endif
            break
    endswitch

End

