#pragma rtGlobals=1		// Use modern global access method.

Function extract_spectrum()
    NVAR energy_steps = root:IP_consts:energy_steps
    NVAR numImages = root:IP_consts:numImages
    if (numImages != energy_steps)
        if (energy_steps == -1)
	    doAlert 0,".dat file is not loaded!"
        else
            doAlert 0,".dat file is not consistent with the stack file!"
        endif    
	return -1
    endif

    SetDataFolder root:IP_consts:
    ControlInfo/W=fileIO E_increaseCheck
    if (V_Value == 1)
        WAVE energy = root:IP_consts:energy
        Duplicate/O energy, spectrum;
        Print "stack is aquired with increasing energies."
    else
        WAVE energy_r = root:IP_consts:energy_r
        Duplicate/O energy_r, spectrum;
        Print "stack is aquired with decreasing energies."
    endif
    Redimension/N=(-1,2) spectrum;

    SetDataFolder root:images
    Variable i=0;
    do 
        ImageStats /M=1/P=(i)/R=M_ROIMask M_Stack;
        spectrum[i][1] = V_avg;
        i += 1;
    while(i<energy_steps);

    // display the spectrum
    DoWindow/K current_spectrum
    Display/K=1/N=current_spectrum/W=(150,100,950,550) spectrum[][1] vs spectrum[][0]
    makeDivmap#make_divmap()
end
